Unix & Linux Stack Exchange is a question and answer site for users of Linux, FreeBSD and other Un*x-like operating systems. It's 100% free, no registration required.

Sign up
Here's how it works:
  1. Anybody can ask a question
  2. Anybody can answer
  3. The best answers are voted up and rise to the top

Sometimes I want to start a process and forget about it. If I start it from the command line, like this:

redshift

I can't close the terminal, or it will kill the process. Can I run a command in such a way that I can close the terminal without killing the process?

share|improve this question
3  
Not a default install on all distros, but screen is your friend: en.wikipedia.org/wiki/GNU_Screen – Zayne S Halsall Nov 13 '10 at 14:23
    
To anyone facing the same problem: Remember, that even if you type yourExecutable & and the outputs keep coming on the screen and Ctrl+C does not seem to stop anything, just blindly type disown; and press Enter even if the screen is scrolling with outputs and you can't see what you're typing. The process will get disowned and you'll be able to close the terminal without the process dying. – Nav Apr 21 at 11:18

11 Answers 11

up vote 147 down vote accepted

One of the following 2 should work:

$ nohup redshift &

or

$ redshift &
$ disown

See the following for a bit more information on how this works:

share|improve this answer
2  
The second one (redshift & disown) worked for me on Ubuntu 10.10. It seems to work fine putting it all on one line. Is there any reason that I shouldn't do this? – Matthew Pirocchi Nov 13 '10 at 0:52
3  
@Matthew The first should work fine too, it just doesn't background like the second (you possibly want nohup redshift & so it does background). And putting the second on one line is fine, although usually you separate with ; (redshift &; disown) – Michael Mrozek Nov 13 '10 at 3:14
6  
@Michael: Both ; and & are command separators and have equal precedence. The only difference is the synchronous versus asynchronous execution (respectively). There is no need to use &; in preference to just & (it works, but it is a bit redundant). – Chris Johnsen Nov 13 '10 at 4:29
2  
good answer, one might add that it would be a good idea to redirect stdout and stderr so that the terminal won't be spammed with debug output – Kim Nov 13 '10 at 6:22
2  
Also, redshift &! will disown redshift immediately. – Evan Teitelman Apr 21 '13 at 18:30

If your program is already running you can pause it with Ctrl-Z, pull it into the background with bg and then disown it, like this:

$ sleep 1000
^Z
[1]+  Stopped                 sleep 1000
$ bg
$ disown
$ exit
share|improve this answer
2  
+1 for ctrl-z; I was unaware of it's function. – virtualxtc Feb 16 '14 at 22:52
1  
after disown how can I again read the stdout of the running process? – neckTwi May 22 '14 at 10:59
1  
@neckTwi, serverfault.com/questions/55880/… – Stefan May 22 '14 at 11:23
    
This didn't work for me for some reason (centos) – Ian Apr 17 '15 at 13:42
    
+1 this is exactly what i was looking for – benka Apr 29 at 21:24

Good answer is already posted by @StevenD, yet I think this might clarify it a bit more.

The reason that the process is killed on termination of the terminal is that the process you start is a child process of the terminal. Once you close the terminal, this will kill these child processes as well. You can see the process tree with pstree, for example when running kate & in Konsole:

init-+
     ├─konsole─┬─bash─┬─kate───2*[{kate}]
     │         │      └─pstree
     │         └─2*[{konsole}]

To make the kate process detached from konsole when you terminate konsole, use nohup with the command, like this:

nohup kate &

After closing konsole, pstree will look like this:

init-+
     |-kate---2*[{kate}]

and kate will survive. :)

An alternative is using screen/tmux/byobu, which will keep the shell running, independent of the terminal.

share|improve this answer
    
I had problems with the disown methods. This is currently working for me, so upvoting. I also like this because I can tail -f nohup.out to see whats happening, but not worry about my session failing – Ian Apr 17 '15 at 13:44

You can run the process like this in the terminal

setsid process

This will run the program in a new session. As explained http://hanoo.org/index.php?article=run-program-in-new-session-linux

share|improve this answer
1  
What do you see as the advantages of setsid over nohup? – itsbruce Oct 30 '12 at 10:52
1  
1) It doesn't print an annoying message about nohup.out. 2) It doesn't remain in your shell's job list, so it doesn't clutter the output of jobs. – Mikel Nov 6 '12 at 22:24

I have a script to:

  • Run arbitrary commands in the background

  • Stop them from being killed with the terminal window

  • Suppress their output

  • Handles exit status

I use it mainly for gedit, evince, inkscape etc that all have lots of annoying terminal output. If the command finishes before TIMEOUT, nohup's exit status is returned instead of zero.

#!/bin/bash

TIMEOUT=0.1

#use nohup to run the command, suppressing its output and allowing the terminal to be closed
#also send nohup's output to /dev/null, supressing nohup.out
#run nohup in the background so this script doesn't block
nohup "${@}" >/dev/null 2>&1 &
NOHUP_PID=$!

#kill this script after a short time, exiting with success status - command is still running
#this is needed as there is no timeout argument for `wait` below
MY_PID=$$
trap "exit 0" SIGINT SIGTERM
sleep $TIMEOUT && kill $MY_PID 2>/dev/null & #ignore "No such process" error if this exits normally

#if the command finishes before the above timeout, everything may be just fine or there could have been an error
wait $NOHUP_PID
NOHUP_STATUS=$?
#print an error if there was any. most commonly, there was a typo in the command
[ $NOHUP_STATUS != 0 ] && echo "Error ${@}"
#return the exit status of nohup, whatever it was
exit $NOHUP_STATUS

examples...

>>> run true && echo success || echo fail
success
>>> run false && echo success || echo fail
Error false
fail
>>> run sleep 1000 && echo success || echo fail
success
>>> run notfound && echo success || echo fail
Error notfound
fail
share|improve this answer

Though all of the suggestions work well, I've found my alternative is to use screen, a program that sets up a virtual terminal on your screen.

You might consider starting it with screen -S session_name. Screen can be installed on virtually all Linux and Unix derivatives. Hitting Ctrl+A and (lower case) C will start a second session. This would allow you to toggle back and forth between the initial session by hitting Ctrl+A and 0 or the newer session by hitting Ctrl+A and 1. You can have up to ten sessions in one terminal. I used to start a session at work, go home, ssh into my work machine, and then invoke screen -d -R session_name. This will reconnect you to that remote session.

share|improve this answer

I prefer:

(applicationName &)

for example: linux@linux-desktop:~$ (chromium-browser &)

share|improve this answer

You can use screen multiplexer such tmux. It is available via apt-get on ubuntu machines

share|improve this answer

The shell-only way to do all this is to close stdin and background the command:

command <&- & 

Then it won't quit when you quit the shell. Redirecting stdout is a nice optional thing to do.

Disadvantage is that you can't do this after the fact.

share|improve this answer
    
Didn't know about <&- thanks. – Jesse Chisholm Nov 13 '15 at 0:25

You can set a process (PID) to not receive a HUP signal upon logging out and closing the terminal session. Use the following command:

nohup -p PID
share|improve this answer

Arguably similar to the answer offered by apolinsky, I use a variant on screen. The vanilla command is like this

screen bash -c 'long_running_command_here; echo; read -p "ALL DONE:"'

The session can be disconnected with Ctrl ACtrl D and reconnected in the simple case with screen -r. I have this wrapped in a script called session that lives in my PATH ready for convenient access:

#!/bin/bash
#
if screen -ls | awk '$1 ~ /^[1-9][0-9]*\.'"$1"'/' >/dev/null
then
    echo "WARNING: session is already running (reattach with 'screen -r $1')" >&2
else
    exec screen -S "$1" bash -c "$@; echo; echo '--------------------'; read -p 'ALL DONE (Enter to exit):'"
    echo "ERROR: 'screen' is not installed on this system" >&2
fi
exit 1

This only works when you know in advance you want to disconnect a program. It does not provide for an already running program to be disconnected.

share|improve this answer

Your Answer

 
discard

By posting your answer, you agree to the privacy policy and terms of service.

Not the answer you're looking for? Browse other questions tagged or ask your own question.